//#########################################################################
// File: tape.c
//Filebertragung (.tap mit Blocknummer) an den KC 
// als Tape-Signal
//#########################################################################
// Last change: 30.11.2007
//#########################################################################
// by Kingstener
//#########################################################################
// Processor: ATMega32
//#########################################################################
// Compiler: WinAVR
//#########################################################################

#include <avr/io.h>

#include "tape.h"
#include "lcd.h"
#include "dos.h"
#include "mydefs.h"
#include "printf.h"
//#########################################################################
void Upload(void)//Tape Uploader
//#########################################################################
{
	unsigned char count; //Bytezhler
	unsigned int i,j,k;
	char line[130];
	j=0;
	
	if(Fopen("load87",F_READ))
    {
	printf("load87...");
	count=Fread(line,16);//Vorspann ausblenden
	while((count=Fread(line,129))) //1 block lesen 
		{ 
		vorton(j);j++;k=0;//Vorton
		byteout(line[0]);//Blocknummer ausgeben
		for(i=1; i<count; i++)	
			{
			byteout(line[i]);//Datenblock
			k=k+(line[i]);//Prfsumme bilden
			}
		byteout(k);//Prfsumme ausgeben
		}
	Fclose();//fertig
	LCDCls();
	}
  
 }
//######################################################################### 
void byteout(unsigned char c)  //Byteausgabe
//#########################################################################
  {
	unsigned int z;	//bitzhler
	for(z=0;z<8;z++) {  if (c & (1 << z)) {bith();} else {bitl();};} //Einzelbits auswerten
	trennz();
  }
//#########################################################################
void bitl (void)  //Ausgabe 0-Bit 2400Hz
//#########################################################################
  {
  	Delay10us(20);		// 208s
	PORTD |= (1<<PD7); // Bit setzen
	Delay10us(20);		// 208s
	PORTD &= ~(1<<PD7); // bit lschen
  }

//#########################################################################
void bith (void)  //Ausgabe 1-Bit 1200 Hz
//#########################################################################
  {
   	Delay10us(40);		// 416s
	PORTD |= (1<<PD7); // Bit setzen
	Delay10us(40);		// 416s
	PORTD &= ~(1<<PD7); // bit lschen
  }

//#########################################################################
void trennz (void)//1 Trennzeichen 600Hz
//#########################################################################
  {
   	Delay10us(83);		// 830s
	PORTD |= (1<<PD7); // Bit setzen
	Delay10us(83);		// 830s
	PORTD &= ~(1<<PD7); // bit lschen
  }
  
//#########################################################################  
void vorton (unsigned int len)//vorton 8000xbith
//#########################################################################
{
 unsigned int m,n,o;
 if (len==0) {o=50;} else {o=2;}// eigentlich 8000 also 200x40,war mir zu lang
 for(m=0; m<o; m++)				// als Vorton,die else ist fr Folgeblcke
 { 
   for(n=0; n<40; n++)
    {
     bith();
    }
  }
trennz();
}

//##########################################################################
//Nicht sonderlich genau !!
void Delay10us(unsigned char time)
//##########################################################################
{
 unsigned char k,l;

 for(k=0; k<time; k++)
  {
   for(l=0; l<7; l++)
    {
     //Ein CPU-Clock = 0.07us bei 14,3MHz
     NOP(); NOP(); NOP(); NOP(); NOP();// NOP(); NOP(); NOP(); NOP(); NOP(); //frequenz mu noch optimiert 
     NOP(); NOP(); NOP(); NOP(); NOP(); //NOP(); NOP(); NOP(); NOP(); NOP(); //werden 
    }
  }
}
