#!/usr/local/bin/perl
# Rekursives Traversieren mit File::Find
# Umbenennen der tap-Files
# V.Pohlers, 2008

use File::Find;

my @biggest  = ( '', 0 );
my @youngest = ( '', 0 );
@ARGV = "." unless defined @ARGV;

find(\&wanted, @ARGV);		  # Rekursiver Alg.


# Diese Funktion wird fuer jeden Verzeichniseintrag aufgerufen.
# Der Name des aktuellen Verzeichnisses
# befindet sich in $File::Find::dir.
# Der Name der aktuellen Datei
# in diesem Verzeichnis liegt in $_.
# Wir sind hier implizit chdir($File::Find::dir) geworden,
# so dass wir auf $_ direkt zugreifen koennen.

sub wanted {
	my $file;
	$file = $_;
	# $File::Find::name ist "$File::Find::dir/$_"
	return unless -f;	# raus, wenn wir keine echte Datei haben

	if (/\.tap$/) {
		print STDERR "Examining: ", $File::Find::name, "\n" if $^W;
		print $File::Find::name, ': ';
		rename ($file, newname($file)) or die "Error in rename: $!\n";
	}
}

sub newname {
	my $name;
	
	open IN, "<".shift;
	binmode IN;

	# Header lesen
	read IN, $block, 16; 
	if ($block ne 'KC-TAPE by AF. ') {
		close IN;
		print 'Kein TAP-Format!';
	}

	# Blocknummer
	read IN, $block, 1; 
	# printf "%.2lX ", ord $block;
	
	# Programmname
	read IN, $_, 11;
	#print "$_ -> ";	
	close IN;
	
	if ( /^([\xD3-\xD5\xD7-\xD9]){3}/ ) {
		print "BASIC ";
		$name = substr($_,3);
	} else {
		print "MC ";
		$name = $_;
		substr($name,7,1) = '.';
	}

	$name =~ tr/+/-/;
	$name =~ s/[\x00 ]//g;

	print $name, "\n";
	
	return $name;
}
